function withData(param) {
  return param < 10 ? '0' + param : '' + param;
}

function getLoopArray(start, end, way) {
  var start = start || 0;
  var end = end || 1;
  var array = [];
  for (var i = start; i <= end; i++) {
    array.push(withData(i) + way);
  }
  return array;
}

function getMonthDay(year, month) {
 const yearStr = year.slice(0,year.length-1)
 const monthStr = month.slice(0,month.length-1)
  var flag = yearStr % 400 == 0 || (yearStr % 4 == 0 && yearStr % 100 != 0),
    array = null;

  switch (monthStr) {
    case '01':
    case '03':
    case '05':
    case '07':
    case '08':
    case '10':
    case '12':
      array = getLoopArray(1, 31, "日")
      break;
    case '04':
    case '06':
    case '09':
    case '11':
      array = getLoopArray(1, 30, "日")
      break;
    case '02':
      array = flag ? getLoopArray(1, 29, "日") : getLoopArray(1, 28, "日")
      break;
    default:
      array = '月份格式不正确，请重新输入！'
  }
  return array;
}

function getNewDateArry() {
  // 当前时间的处理
  var newDate = new Date();
  var year = withData(newDate.getFullYear())+"年";
  var mont = withData(newDate.getMonth() + 1) + "月",
    date = withData(newDate.getDate()) + "日",
    hour = withData(newDate.getHours()) + "时",
    minu = withData(newDate.getMinutes()) + "分",
    seco = withData(newDate.getSeconds()) + "秒";

  return [year, mont, date, hour, minu];
}

function dateTimePicker(date) {
  // 返回默认显示的数组和联动数组的声明
  var dateTime = [],
    dateTimeArray = [
      [],
      [],
      [],
      [],
      [],
    ];
  // 默认开始显示数据
  var defaultDate = date ? [...date.split(' ')[0].split('-'), ...date.split(' ')[1].split(':')] : getNewDateArry();
  var start = defaultDate[0].slice(0,defaultDate[0].length-1);
  var end = 2100;
  var dayEnd = getMonthDay(defaultDate[0], defaultDate[1])
  // 处理联动列表数据
  /*年月日 时分秒*/
  dateTimeArray[0] = getLoopArray(start, end, "年");
  dateTimeArray[1] = getLoopArray(parseInt(defaultDate[1]), 12, "月");
  // dateTimeArray[2] = getLoopArray(parseInt(defaultDate[2]), dayEnd.length, "日");
  dateTimeArray[2] = dayEnd
  dateTimeArray[3] = getLoopArray(0, 23, "时");
  dateTimeArray[4] = getLoopArray(0, 59, "分");

  dateTimeArray.forEach((current, index) => {
    dateTime.push(current.indexOf(defaultDate[index]));
  });

  return {
    dateTimeArray: dateTimeArray,
    dateTime: dateTime
  }
}
module.exports = {
  dateTimePicker: dateTimePicker,
  getMonthDay: getMonthDay,
  getLoopArray: getLoopArray
}